close tables all

public goGestError
*---> Cration de l'objet permetttant de grer les erreurs
m.goGestError = CreateObject("GestError")
*---> Rattachement  on error
on error m.goGestError.OnError()

Main()

procedure Main()
  PrepareOutlook()  
endproc && Main


procedure PrepareOutlook()
  try
     m.oOutlook = CreateObject("Outlook.Application")
  catch to m.oErr when m.oErr.ErrorNo = 1733
    *---> On fait remonter un objet OutlookException
    m.goGestError.Throw(CreateObject("OutlookException"))
  catch to m.oErr
    m.goGestError.Throw(m.oErr)
  endtry
endproc && PrepareOutlook

*--------------------------------------------------------------------------*
* Erreur critique : message d'alerte
define class AlertException as Exception

  procedure Init()
    MessageBox(this.Message, 16, "Erreur critique")
  endproc && Init
  
enddefine && CriticalException

*--------------------------------------------------------------------------*
* Erreur OutLook
define class OutlookException as AlertException

  ErrorNo = 5001
  Message = "Outlook n'est pas install sur la machine"
  
enddefine

*--------------------------------------------------------------------------*
* Gestionnaire d'erreurs
define class GestError as Custom
  
  hidden LastException
  LastException = null

  procedure Throw(oErr as Exception)
    with this
      *---> On stocke l'erreur releve dans la proprit LastException
      .LastException = m.oErr
      throw m.oErr
    endwith
  endproc && Throw
  
  procedure OnError()
  local cMessage, nError, oData
    with this
      if !Used("ERREURS")
        select 0
        use erreurs.dbf alias ERREURS shared again
      endif
      scatter memo blank name m.oData
      m.oData.DateHeure = Datetime()
      *---> L'erreur provient d'un objet Exception
      if !IsNull(.LastException)
        m.oData.Error = .LastException.ErrorNo
        m.oData.Message = .LastException.Message
        m.oData.ExcClass = .LastException.Class
      *---> Autre erreur
      else
        m.oData.Error = Error()
        m.oData.Message = Message()
      endif
      m.oData.StackInfo = .GetStackInfo()
      *---> Enregistrement dans la table ERREURS
      insert into ERREURS from name m.oData
      browse
      *---> Fermeture du programme
      cancel
    endwith
  endproc && OnError
  
  *---> Rcupre la pile d'excution
  hidden function GetStackInfo() as String
  local nI, cInfo
  local array aPiles(1)
    m.cInfo = ""
    for m.nI = 1 to AStackInfo(m.aPiles) - 2
      text to m.cInfo additive textmerge noshow
Profondeur : <<m.aPiles[m.nI, 1]>>
Programme : <<m.aPiles[m.nI, 2]>>
Module / objet : <<m.aPiles[m.nI, 3]>>
Fichier source : <<m.aPiles[m.nI, 4]>>
N de ligne : <<m.aPiles[m.nI, 5]>>
Contenu de la ligne : <<m.aPiles[m.nI, 6]>>
#

      endtext
    next
    return m.cInfo
  endfunc && GetStackInfo
  
enddefine && ErrorMapping